/* ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : RTC1.c
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : RTC_Maxim
**     Version     : Component 01.003, Driver 01.00, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2013-07-01, 17:48, # CodeGen: 0
**     Abstract    :
**
**     Settings    :
**          Component name                                 : RTC1
**          Device                                         : DS1307
**          I2C                                            : GI2C1
**          Utility                                        : UTIL1
**          Shell                                          : Disabled
**     Contents    :
**         GetRTCTimeDate - byte RTC1_GetRTCTimeDate(RTC1_TTIME *time, RTC1_TDATE *date);
**         SetRTCTimeDate - byte RTC1_SetRTCTimeDate(RTC1_TTIME *time, RTC1_TDATE *date);
**         GetRTCTime     - byte RTC1_GetRTCTime(RTC1_TTIME *time);
**         SetRTCTime     - byte RTC1_SetRTCTime(RTC1_TTIME *time);
**         GetRTCDate     - byte RTC1_GetRTCDate(RTC1_TDATE *date);
**         SetRTCDate     - byte RTC1_SetRTCDate(RTC1_TDATE *date);
**         GetTime        - byte RTC1_GetTime(TIMEREC *time);
**         SetTime        - byte RTC1_SetTime(byte Hour, byte Min, byte Sec, byte Sec100);
**         GetDate        - byte RTC1_GetDate(DATEREC *date);
**         SetDate        - byte RTC1_SetDate(word Year, byte Month, byte Day);
**         Read           - byte RTC1_Read(byte addr, byte *buf, byte bufSize);
**         Write          - byte RTC1_Write(byte addr, byte *buf, byte bufSize);
**         ReadByte       - byte RTC1_ReadByte(byte addr, byte *buf);
**         WriteByte      - byte RTC1_WriteByte(byte addr, byte buf);
**         ReadBlock      - byte RTC1_ReadBlock(byte addr, byte *buf, byte bufSize);
**         WriteBlock     - byte RTC1_WriteBlock(byte addr, byte *buf, byte bufSize);
**         Init           - void RTC1_Init(void);
**         Deinit         - void RTC1_Deinit(void);
**
**     License   :  Open Source (LGPL)
**     Copyright : (c) Copyright Erich Styger, 2012, all rights reserved.
**     http          : www.mcuoneclipse.com
**     This an open source software implementing software using Processor Expert.
**     Main purpose is for a file system, but useful as well without one.
**     This is a free software and is opened for education,  research  and commercial developments under license policy of following terms:
**     * This is a free software and there is NO WARRANTY.
**     * No restriction on use. You can use, modify and redistribute it for personal, non-profit or commercial product UNDER YOUR RESPONSIBILITY.
**     * Redistributions of source code must retain the above copyright notice.
** ###################################################################*/
/*!
** @file RTC1.c
** @version 01.00
** @brief
**
*/         
/*!
**  @addtogroup RTC1_module RTC1 module documentation
**  @{
*/         

/* MODULE RTC1. */

#include "RTC1.h"

/*
** ===================================================================
**     Method      :  RTC1_Read (component RTC_Maxim)
**     Description :
**         Read from the device
**     Parameters  :
**         NAME            - DESCRIPTION
**         addr            - device memory address
**       * buf             - Pointer to read buffer
**         bufSize         - Size of read buffer
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTC1_Read(byte addr, byte *buf, byte bufSize)
{
  return GI2C1_ReadAddress(RTC1_DEVICE_ADDRESS, &addr, 1, buf, bufSize);
}

/*
** ===================================================================
**     Method      :  RTC1_Write (component RTC_Maxim)
**     Description :
**         Write from the device
**     Parameters  :
**         NAME            - DESCRIPTION
**         addr            - device memory address
**       * buf             - Pointer to read buffer
**         bufSize         - 
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTC1_Write(byte addr, byte *buf, byte bufSize)
{
  return GI2C1_WriteAddress(RTC1_DEVICE_ADDRESS, &addr, 1, buf, bufSize);
}

/*
** ===================================================================
**     Method      :  RTC1_ReadByte (component RTC_Maxim)
**     Description :
**         Read from the device RAM
**     Parameters  :
**         NAME            - DESCRIPTION
**         addr            - device memory address, with zero as the
**                           RAM start address
**       * buf             - Pointer to read buffer
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTC1_ReadByte(byte addr, byte *buf)
{
  if (addr>RTC1_MAX_ADDRESS) {
    return ERR_RANGE; /* memory address out of range */
  }
  addr += RTC1_MEM_RAM_START_ADDR;
  return GI2C1_ReadAddress(RTC1_DEVICE_ADDRESS, &addr, 1, buf, 1);
}

/*
** ===================================================================
**     Method      :  RTC1_WriteByte (component RTC_Maxim)
**     Description :
**         Read from the device RAM
**     Parameters  :
**         NAME            - DESCRIPTION
**         addr            - device memory address, with zero as the
**                           RAM memory start address
**         buf             - value to write
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTC1_WriteByte(byte addr, byte buf)
{
  if (addr>RTC1_MAX_ADDRESS) {
    return ERR_RANGE; /* memory address out of range */
  }
  addr += RTC1_MEM_RAM_START_ADDR;
  return GI2C1_WriteAddress(RTC1_DEVICE_ADDRESS, &addr, 1, &buf, 1);
}

/*
** ===================================================================
**     Method      :  RTC1_ReadBlock (component RTC_Maxim)
**     Description :
**         Read from the device RAM
**     Parameters  :
**         NAME            - DESCRIPTION
**         addr            - device memory address, with zero as the
**                           RAM start address
**       * buf             - Pointer to read buffer
**         bufSize         - Size of read buffer
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTC1_ReadBlock(byte addr, byte *buf, byte bufSize)
{
  if (addr>RTC1_MAX_ADDRESS || (addr+bufSize)>RTC1_MEM_SIZE) {
    return ERR_RANGE; /* memory address out of range */
  }
  addr += RTC1_MEM_RAM_START_ADDR;
  return GI2C1_ReadAddress(RTC1_DEVICE_ADDRESS, &addr, 1, buf, bufSize);
}

/*
** ===================================================================
**     Method      :  RTC1_WriteBlock (component RTC_Maxim)
**     Description :
**         Read from the device RAM
**     Parameters  :
**         NAME            - DESCRIPTION
**         addr            - device memory address, with zero as the
**                           RAM memory start address
**       * buf             - Pointer to read buffer
**         bufSize         - 
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTC1_WriteBlock(byte addr, byte *buf, byte bufSize)
{
  if (addr>RTC1_MAX_ADDRESS || (addr+bufSize)>RTC1_MEM_SIZE) {
    return ERR_RANGE; /* memory address out of range */
  }
  addr += RTC1_MEM_RAM_START_ADDR;
  return GI2C1_WriteAddress(RTC1_DEVICE_ADDRESS, &addr, 1, buf, bufSize);
}

/*
** ===================================================================
**     Method      :  RTC1_GetRTCTimeDate (component RTC_Maxim)
**     Description :
**         Returns the time and date from the device.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * time            - Pointer to time
**       * date            - Pointer to date
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTC1_GetRTCTimeDate(RTC1_TTIME *time, RTC1_TDATE *date)
{
  byte buf[RTC1_MEM_TIME_DATE_SIZE];

  if (RTC1_Read(RTC1_MEM_TIME_DATE_ADDR, buf, sizeof(buf))!=ERR_OK) {
    return ERR_FAILED;
  }
  time->sec = (byte)(((buf[0]&0x70)>>4)*10 + (buf[0]&0x0F));
  time->min = (byte)((buf[1]>>4)*10 + (buf[1]&0x0F));
  if (buf[2]&0x40) {
    time->hour =(byte)(buf[2]&0x1F);
    time->mode = RTC1_TTIME_MODE_12H;
    time->am_pm =(byte)((buf[2]&0x20)>>5);
  } else {
    time->hour = (byte)(buf[2]&0x3F);
    time->mode = RTC1_TTIME_MODE_24H;
  }
  time->hour = (byte)((time->hour>>4)*10 + (buf[2]&0x0F));
  date->dayOfWeek =(byte)(buf[3]-1);
  date->day = (byte)((buf[4]>>4)*10 + (buf[4]&0x0F));
  date->month = (byte)((buf[5]>>4)*10 + (buf[5]&0x0F));
  date->year = (byte)((buf[6]>>4)*10 + (buf[6]&0x0F));
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  RTC1_SetRTCTimeDate (component RTC_Maxim)
**     Description :
**         Sets the date and time.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * time            - Pointer to time to be set
**       * date            - Pointer to date to be set
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTC1_SetRTCTimeDate(RTC1_TTIME *time, RTC1_TDATE *date)
{
  byte buf[RTC1_MEM_TIME_DATE_SIZE];

  if (   ((time->mode==RTC1_TTIME_MODE_12H)&&((time->hour>12)||(time->hour==0)))
      || ((time->mode==RTC1_TTIME_MODE_24H)&&(time->hour>23))
      || (time->min>59)||(time->sec>59)
      || (date->year>99)||(date->month>12)||(date->month==0)
      || (date->day>31)||(date->day==0)
      || (date->dayOfWeek>6))
  {
    return ERR_RANGE;
  }
  buf[0] = (byte)(((time->sec/10)<<4) | (time->sec%10));
  buf[1] = (byte)(((time->min/10)<<4) | (time->min%10));
  buf[2] = (byte)(((time->hour/10)<<4) | (time->hour%10));
  if (time->mode==RTC1_TTIME_MODE_12H) {
    buf[2] |= (time->am_pm)?0x60:0x40;
  }
  buf[3] = (byte)(date->dayOfWeek+1);
  buf[4] = (byte)(((date->day/10)<<4) | (date->day%10));
  buf[5] = (byte)(((date->month/10)<<4) | (date->month%10));
  buf[6] = (byte)(((date->year/10)<<4) | (date->year%10));
  if (RTC1_Write(RTC1_MEM_TIME_DATE_ADDR, buf, sizeof(buf))!=ERR_OK) {
    return ERR_FAILED;
  }
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  RTC1_SetRTCTime (component RTC_Maxim)
**     Description :
**         Sets the time using the RTC low level information.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * time            - Pointer to time to be set
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTC1_SetRTCTime(RTC1_TTIME *time)
{
  byte buf[RTC1_MEM_TIME_SIZE];

  if (   ((time->mode==RTC1_TTIME_MODE_12H)&&((time->hour>12)||(time->hour==0)))
      || ((time->mode==RTC1_TTIME_MODE_24H)&&(time->hour>23))
      || (time->min>59) || (time->sec>59)
     )
  {
    return ERR_RANGE;
  }
  buf[0] = (byte)(((time->sec/10)<<4) | (time->sec%10));
  buf[1] = (byte)(((time->min/10)<<4) | (time->min%10));
  buf[2] = (byte)(((time->hour/10)<<4) | (time->hour%10));
  if (time->mode==RTC1_TTIME_MODE_12H) {
    buf[2] |= (time->am_pm)?0x60:0x40;
  }
  if (RTC1_Write(RTC1_MEM_TIME_ADDR, buf, sizeof(buf))!=ERR_OK) {
    return ERR_FAILED;
  }
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  RTC1_GetRTCTime (component RTC_Maxim)
**     Description :
**         Returns the time using the RTC low level information.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * time            - Pointer to time
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTC1_GetRTCTime(RTC1_TTIME *time)
{
  byte buf[RTC1_MEM_TIME_SIZE];

  if (RTC1_Read(RTC1_MEM_TIME_ADDR, buf, sizeof(buf))!=ERR_OK) {
    return ERR_FAILED;
  }
  time->sec = (byte)(((buf[0]&0x70)>>4)*10 + (buf[0]&0x0F));
  time->min = (byte)((buf[1]>>4)*10 + (buf[1]&0x0F));
  if (buf[2]&0x40) {
    time->hour =(byte)(buf[2]&0x1F);
    time->mode = RTC1_TTIME_MODE_12H;
    time->am_pm = (byte)((buf[2]&0x20)>>5);
  } else {
    time->hour = (byte)(buf[2]&0x3F);
    time->mode = RTC1_TTIME_MODE_24H;
  }
  time->hour = (byte)((time->hour>>4)*10 + (buf[2]&0x0F));
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  RTC1_GetRTCDate (component RTC_Maxim)
**     Description :
**         Returns the date from the device using the RTC low level
**         information.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * date            - Pointer to date
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTC1_GetRTCDate(RTC1_TDATE *date)
{
  byte buf[RTC1_MEM_DATE_SIZE];

  if (RTC1_Read(RTC1_MEM_DATE_ADDR, buf, sizeof(buf))!=ERR_OK) {
    return ERR_FAILED;
  }
  date->dayOfWeek =(byte)(buf[0]-1);
  date->day = (byte)((buf[1]>>4)*10 + (buf[1]&0x0F));
  date->month = (byte)((buf[2]>>4)*10 + (buf[2]&0x0F));
  date->year = (byte)((buf[3]>>4)*10 + (buf[3]&0x0F));
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  RTC1_SetRTCDate (component RTC_Maxim)
**     Description :
**         Sets the date using the RTC low level information.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * date            - Pointer to date to be set
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTC1_SetRTCDate(RTC1_TDATE *date)
{
  byte buf[RTC1_MEM_DATE_SIZE];

  if (   (date->year>99)
      || (date->month>12)||(date->month==0)
      || (date->day>31)||(date->day==0)
      || (date->dayOfWeek>6)
     )
  {
    return ERR_RANGE;
  }
  buf[0] = (byte)(date->dayOfWeek + 1);
  buf[1] = (byte)(((date->day/10)<<4) | (date->day%10));
  buf[2] = (byte)(((date->month/10)<<4) | (date->month%10));
  buf[3] = (byte)(((date->year/10)<<4) | (date->year%10));
  if (RTC1_Write(RTC1_MEM_DATE_ADDR, buf, sizeof(buf))!=ERR_OK) {
    return ERR_FAILED;
  }
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  RTC1_Init (component RTC_Maxim)
**     Description :
**         Initializes the driver.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void RTC1_Init(void)
{
  /* nothing to do */
}

/*
** ===================================================================
**     Method      :  RTC1_Deinit (component RTC_Maxim)
**     Description :
**         Deinitializes the driver.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void RTC1_Deinit(void)
{
  /* nothing to do */
}

/*
** ===================================================================
**     Method      :  RTC1_GetTime (component RTC_Maxim)
**     Description :
**         Returns the time.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * time            - Pointer to time
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTC1_GetTime(TIMEREC *time)
{
  RTC1_TTIME ttime;

  if (RTC1_GetRTCTime(&ttime)!=ERR_OK) {
    return ERR_FAILED;
  }
  time->Hour = ttime.hour;
  time->Min = ttime.min;
  time->Sec = ttime.sec;
  time->Sec100 = 0;
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  RTC1_SetTime (component RTC_Maxim)
**     Description :
**         Sets the time.
**     Parameters  :
**         NAME            - DESCRIPTION
**         Hour            - Hours (0 - 23)
**         Min             - Minutes (0 - 59)
**         Sec             - Seconds (0 - 59)
**         Sec100          - Hundredths of seconds (0 - 99)
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTC1_SetTime(byte Hour, byte Min, byte Sec, byte Sec100)
{
  RTC1_TTIME ttime;

  ttime.hour = Hour;
  ttime.min = Min;
  ttime.sec = Sec;
  (void)Sec100; /* ignored, as cannot be stored on device */
  ttime.mode = RTC1_TTIME_MODE_24H;
  ttime.am_pm = RTC1_TTIME_AMPM_AM;
  return RTC1_SetRTCTime(&ttime);
}

/*
** ===================================================================
**     Method      :  RTC1_GetDate (component RTC_Maxim)
**     Description :
**         Returns the time and date from the device.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * date            - Pointer to date
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTC1_GetDate(DATEREC *date)
{
  RTC1_TDATE tdate;

  if (RTC1_GetRTCDate(&tdate)!=ERR_OK) {
    return ERR_FAILED;
  }
  date->Year = (word)(tdate.year+2000);
  date->Month = tdate.month;
  date->Day = tdate.day;
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  RTC1_SetDate (component RTC_Maxim)
**     Description :
**         Sets the date.
**     Parameters  :
**         NAME            - DESCRIPTION
**         Year            - Year in 2000 format
**         Month           - Month number (1..12)
**         Day             - Day number (1..31)
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTC1_SetDate(word Year, byte Month, byte Day)
{
  RTC1_TDATE tdate;

  tdate.year = (byte)(Year-2000);
  tdate.month = Month;
  tdate.day = Day;
  tdate.dayOfWeek = UTIL1_WeekDay(Year, Month, Day);
  return RTC1_SetRTCDate(&tdate);
}

/* END RTC1. */

/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.2 [05.06]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
